<script lang="ts">
import Vue from 'vue';
import { cloneDeep } from 'lodash';
import FeaturesProductsCategoryCards from './features-product-category-cards.vue';
import FeaturesCtaSection from './features-cta-section.vue';

export default Vue.extend({
  name: 'FeaturesContent',
  components: {
    FeaturesProductsCategoryCards,
    FeaturesCtaSection,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
    filter: {
      type: Object,
      required: true,
    },
    contentConfig: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      filteredData: [],
      isLoading: true,
    };
  },
  watch: {
    filter(newFilter: any) {
      this.isLoading = true;
      this.featuresByCategory(this.data, newFilter);
    },
  },
  beforeMount() {
    this.featuresByCategory(this.data, this.filter);
  },
  methods: {
    scrollToTop() {
      window.scrollTo({ top: 0, behavior: 'smooth' });
    },
    featuresByCategory(data: any, filter: any) {
      const clonedData = cloneDeep(data.features);
      this.filteredData = clonedData.map((item: any) => {
        return {
          ...item,
          features: item.features.map((feature: any) => {
            const itemCopy = { ...feature };
            itemCopy.aos_animation = 'fade-up';
            itemCopy.aos_duration = 500;
            const isCore =
              feature.gitlab_free ||
              (!(
                feature.gitlab_com === false ||
                feature.gitlab_com === 'not_applicable'
              ) &&
                feature.gitlab_core);
            const isSilver =
              feature.gitlab_silver ||
              (!(
                feature.gitlab_com === false ||
                feature.gitlab_com === 'not_applicable'
              ) &&
                feature.gitlab_premium);
            const isGold =
              feature.gitlab_gold ||
              (!(
                feature.gitlab_com === false ||
                feature.gitlab_com === 'not_applicable'
              ) &&
                feature.gitlab_ultimate);
            itemCopy.isSelfManaged =
              (feature.gitlab_core && !isCore) ||
              (feature.gitlab_premium && !isSilver) ||
              (feature.gitlab_ultimate && !isGold);
            itemCopy.isFree = feature.gitlab_core || isCore;
            itemCopy.isPremium = feature.gitlab_premium || isSilver;
            itemCopy.isUltimate = feature.gitlab_ultimate || isGold;
            itemCopy.with_opacity = this.processItemFilter(itemCopy, filter);
            return itemCopy;
          }),
        };
      });
      setTimeout(() => {
        this.isLoading = false;
      }, 1000);
    },
    processItemFilter(item: any, filter: any) {
      switch (filter.plan) {
        case 'free':
          return !item.isFree;
        case 'premium':
          return !item.isPremium;
        case 'ultimate':
          return !item.isUltimate;
        default:
          return false;
      }
    },
  },
});
</script>

<template>
  <div class="features-content">
    <section
      v-for="(category, index) in filteredData"
      :id="category.slug"
      :key="index"
    >
      <div v-if="category.features.length">
        <SlpTypography
          tag="h2"
          variant="heading4-bold"
          class="features-product-category__category slp-mb-64"
          :data-aos="contentConfig.header_animation"
          :data-aos-duration="contentConfig.header_animation_duration"
        >
          {{ category.name }}
        </SlpTypography>
        <FeaturesProductsCategoryCards
          :class="{ 'features-content__products-category--loading': isLoading }"
          class="features-content__products-category"
          :data="category.features"
          :column-size="contentConfig.column_size"
          :current-category="category.name"
          :image-base-path="`https://about.gitlab.com/images/feature_page/screenshots/`"
        />
        <FeaturesCtaSection />
      </div>
    </section>
    <div
      class="features-content__placeholder"
      :class="{ 'features-content__placeholder--loading': isLoading }"
    >
      <div class="features-content__placeholder__loader"></div>
    </div>
  </div>
</template>

<style scoped lang="scss">
.features-content {
  margin-bottom: $spacing-96;
  margin-top: $spacing-48;
  padding-left: $spacing-4;
  padding-right: $spacing-4;
  position: relative;
  display: block;

  &__missing-features-button {
    padding: 0;
    border: none;
    background: none;
    cursor: pointer;
    color: $color-text-link-100;
    font-size: $text-body-2;
    transition: all 0.5s ease;

    &:hover {
      filter: brightness(80%);
    }
  }

  &__products-category {
    padding: 0;
    opacity: 1;
    transition: opacity 0.3s ease-in-out;

    @media (min-width: $breakpoint-md) {
      margin-left: -$spacing-16;
    }

    &--loading {
      opacity: 0;
    }
  }

  &__btn {
    color: inherit;
    font-weight: bold;
    transition: all 0.5s ease-in-out;

    &:hover {
      text-decoration: underline;
    }
  }

  &__placeholder {
    background: $color-primary-300;
    position: absolute;
    width: 100%;
    height: 100%;
    left: 0;
    right: 0;
    top: 0;
    opacity: 0;
    transition: opacity 0.3s ease-in-out;
    pointer-events: none;

    &--loading {
      opacity: 0.7;
      pointer-events: all;
    }

    &__loader {
      position: absolute;
      left: 0;
      top: $spacing-160;
      right: 0;
      margin: 0 auto;
      border: $spacing-8 solid $color-primary-100;
      border-top: $spacing-8 solid $color-accent-400;
      border-radius: 50%;
      width: $spacing-48;
      height: $spacing-48;
      animation: spin 2s linear infinite;
    }
  }

  @keyframes spin {
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(360deg);
    }
  }
}
</style>
